#!/usr/bin/env python

import sys
import math

def pV_func(H,D):
    return 10.**(6.259 - 2.*math.log10(D) - 0.4*H)

fin = open("astorb_astdys_wise_sloan.dat_WITH_PROPER_ELMTS", "r")
fout = open("Ktypes.dat", "w")

a1 = 2.85
a2 = 3.25
e1 = 0.0
e2 = 0.3
i1 = 0.06
i2 = 0.3

pV_min = 0.07
pV_max = 0.25

astar_min = 0.0
astar_max = 0.1
iz_min = -0.03
iz_max = 0.08

for line in fin:
    l = line.split()
    a = float(l[35])
    e = float(l[36])
    sinI = float(l[37])
    H_astorb = float(l[34])

    pV_wise = l[49]
    D_iras = l[6]
    if pV_wise != "?":
        pV = float(pV_wise)
    elif D_iras != "?":
        pV = pV_func(H_astorb,float(D_iras))
    else:
        pV = None

    astar = l[88]
    if astar != "?":
        astar = float(astar)
    else:
        astar = None

    i_ = l[86]
    z_ = l[84]
    if i_ != "?" and z_ != "?":
        iz = float(i_)-float(z_)
    else:
        iz = None

    if (a >= a1) and (a <= a2) and (e >= e1) and (e <= e2) and (sinI >= i1) and (sinI <= i2):

        i8r = 0  # interloper

# various tests
        if pV != None and (pV < float(pV_min) or pV > float(pV_max)):
            i8r += 1

        if astar != None and (astar < float(astar_min) or astar > float(astar_max)):
            i8r += 1

        if iz != None and (iz < float(iz_min) or iz > float(iz_max)):
            i8r += 1

        if i8r == 0 and astar != None and iz != None:
            fout.write(line)


fin.close()
fout.close()


